image: registry.actis.cz/actisdevs/exevido/ci

stages:
  - generate
  - finalize
#  - publish

variables:
  TOKEN: "K-ffdX-A7QyxQMuMFype"

.changelog_before: &git_settings
  - env
  - VERSION=`echo "$CI_COMMIT_BRANCH" | cut -d '/' -f2`
  - echo "$VERSION"
  - git remote set-url origin https://oauth2:$TOKEN@gitlab.actis.cz/actisdevs/$CI_PROJECT_NAME.git
  - git config --global user.name 'Gitlab CI'
  - git config --global user.email 'administrator@actis.cz'
  - git tag -d $(git tag -l)  #needed for testing; since the ci repo is fetched, tags stay there
  - git fetch --tags          #and do not get deleted when they're deleted on remote, which causes the task to fail

generate:
  stage: generate
  image: registry.actis.cz/actisdevs/exevido/changelog:latest

  before_script:
    - *git_settings

  script:
    - standard-version --dry-run --release-as "$VERSION" #show changes for major+feat+fix changelog
    - standard-version --release-as "$VERSION"           #generate changelog and commit
    - git push origin HEAD:$CI_COMMIT_REF_NAME           #push generated changelog back to repo

  rules:
    - if: $CI_COMMIT_TITLE != "release-changelog"
      when: manual

after review:
  stage: finalize

  before_script:
    - *git_settings

  script:
    - 'git commit --allow-empty -m "chore(release): release $VERSION finalization"' #prevents "after review" job from running on new release branches
    - git tag $VERSION
    - git push --tags origin HEAD:$CI_COMMIT_REF_NAME

  rules:
    - if: $CI_COMMIT_TITLE == "release-changelog"
      changes:
        - CHANGELOG.md

#publish:
#  stage: publish
#  script:
#    - echo publish #probably curl, if not webhook event
#
#  rules:
#    - when: manual
#  needs:
#    - job: after review
#    - job: skip review
